开启左侧

关于php哈希表多碰撞漏洞补丁问题

[复制链接]
发表于 2012-2-10 18:03:05 | 显示全部楼层 |阅读模式
我照着论坛贴里的网站去下载了php的补丁,按照方法打进去之后,重新make、make install后!启动php时发现eAccelerator加速模块失效了!
[root@localhost eaccelerator-0.9.6.1]# /etc/init.d/php-fpm start
Starting php-fpm [eAccelerator] This build of "eAccelerator" was compiled for PHP version 5.3.8. Rebuild it for your PHP version (5.3.8-p1) or download precompiled binaries.
done
我重新把这个软件编辑过也无效
哪位大虾遇到过这个问题,请教一下,谢过!有分哦
平度网:www.pingdu.co 平度论坛:bbs.pingdu.co
发表于 2012-2-10 18:03:07 | 显示全部楼层
主要是因为php版本号改变了导致eAccelerator报错。
找了一下eAccelerator的源码,发现是eaccelerator.c文件中,有检查php版本号的代码,主要是encode_version这个函数,找到

} else if (strncasecmp(buf, "beta", 4) == 0) {
a = 3;
sscanf(buf, "beta%u", &b);
}

这行,在下面添加如下代码

} else if (buf, "p1%u", &b) {
a = 0;
b = 0;
}

重新编译eAccelerator,再次执行 php -v,已无报错,重启cgi,eAccelerator目录已有重新重成的文件,说明成功解决此问题:)
平度网:www.pingdu.co 平度论坛:bbs.pingdu.co
发表于 2012-2-10 18:03:08 | 显示全部楼层
学习了,可能马上会用到
平度网:www.pingdu.co 平度论坛:bbs.pingdu.co
 楼主| 发表于 2012-2-10 18:03:10 | 显示全部楼层
主要是因为php版本号改变了导致eAccelerator报错。
找了一下eAccelerator的源码,发现是eaccelerator.c文件 ...
朋友说要换版本,我降到0.9.5版本,所有都无效,后来查了一下!发现php5.3.8只支持0.9.6以上的加速~!希望你这个方法能帮助! cry.gif
平度网:www.pingdu.co 平度论坛:bbs.pingdu.co
 楼主| 发表于 2012-2-10 18:03:14 | 显示全部楼层
我这样子改了,但问题依旧~~请问是这样子改吗?
if (buf[0] == 0) {
a = 0;
b = 0;
} else if (strncasecmp(buf, "rev", 3) == 0) {
a = 1;
sscanf(buf, "rev%u", &b);
} else if (strncasecmp(buf, "rc", 2) == 0) {
a = 2;
sscanf(buf, "rc%u", &b);
} else if (strncasecmp(buf, "beta", 4) == 0) {
a = 3;
sscanf(buf, "beta%u", &b);
} else if (buf, "p1%u", &b) {
a = 0;
b = 0;
} else {


367fa93e.jpg
平度网:www.pingdu.co 平度论坛:bbs.pingdu.co
发表于 2012-2-10 18:03:16 | 显示全部楼层
朋友说要换版本,我降到0.9.5版本,所有都无效,后来查了一下!发现php5.3.8只支持0.9.6以上的加速~!希 ...
我的php 5.2.17 重新 编译 eaccelerator-0.9.5.3.tar.bz2 一切正常
平度网:www.pingdu.co 平度论坛:bbs.pingdu.co
发表于 2012-2-10 18:03:19 | 显示全部楼层
太高深了,学习下! lol.gif
平度网:www.pingdu.co 平度论坛:bbs.pingdu.co
 楼主| 发表于 2012-2-10 18:03:21 | 显示全部楼层
我现在也没去弄了~!只能暂时先把加速模块停用,等php5.3.9出来!到时候直接升级至5.3.9吧
平度网:www.pingdu.co 平度论坛:bbs.pingdu.co
发表于 2012-2-10 18:03:24 | 显示全部楼层
或者直接用5.4版本的,,没有这个问题.
平度网:www.pingdu.co 平度论坛:bbs.pingdu.co
 楼主| 发表于 2012-2-10 18:03:26 | 显示全部楼层
或者直接用5.4版本的,,没有这个问题.
5.39还没出来~!也不知道php会直接出5.4~!反正等一下吧,应该很快就出来了,到时候升级一下就好了
平度网:www.pingdu.co 平度论坛:bbs.pingdu.co
您需要登录后才可以回帖 登录 | 会员注册

本版积分规则

 
QQ在线咨询
售前咨询热线
0532-88371356
售后服务微信
pingduwangzhan
快速回复 返回顶部 返回列表